/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 *
 * This software is a multi-platform and portable application based on
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s
 * possible to calculate indicators «RhoMéO» to monitor quality,
 * fonctionalities and urban and agricultural pressures of wetlands.
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.protocol.p05;

import fr.cenra.rhomeo.api.annotations.RefersTo;
import fr.cenra.rhomeo.api.data.Statement;
import fr.cenra.rhomeo.api.data.Warning;
import fr.cenra.rhomeo.core.data.reference.Taxref;
import fr.cenra.rhomeo.protocol.validation.DeterminedSpecies;
import java.time.LocalDate;
import java.util.Objects;
import java.util.function.Predicate;
import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javax.validation.constraints.NotNull;

/**
 *
 * @author Samuel Andrés (Geomatys)
 *
 * @see Taxref
 */
public class OrthopteraStatement extends Statement {

    private final IntegerProperty cd_nomProperty = new SimpleIntegerProperty();

    public OrthopteraStatement() {
    }

    /**
     *
     * @param trackingPoint Tracking point's name.
     * @param date Statement date.
     * @param remarks
     * @param speciesName CD_NOM (TAXREF) ({@link Taxref}) which is expected to be a CD_REF.
     */
    public OrthopteraStatement(final String trackingPoint, final LocalDate date, final String remarks, final int speciesName) {
        super(trackingPoint, date, remarks);
        this.cd_nomProperty.set(speciesName);
    }

    public IntegerProperty cd_nomProperty() {
        return cd_nomProperty;
    }

    public void setCd_nom(final int speciesName) {
        this.cd_nomProperty.set(speciesName);
    }

    /**
     * NOM_ESPECES.
     *
     * (Source : CCTP)
     *
     * […] FROM […]
     * […] expertise.obs_especes […]
     * JOIN referentiels_non_geo.taxref ON obs_especes.cd_ref = taxref.cd_nom::text
     *
     * (Source : I05 and I09 description from the CCTP)
     *
     * A cd_nom which is potentially used to reference the corresponding cd_ref
     * into the processes. Old statements have several taxonomic ids, but we need
     * here a taxonomic id referencing taxref.cd_nom.
     *
     * @return
     */
    @NotNull // Used for fx editor only
    @RefersTo(type=Taxref.class, property = Taxref.ATT_CD_NOM, filterClass = OrthopteraOnly.class)
    @DeterminedSpecies(payload=Warning.class)
    public int getCd_nom() {
        return cd_nomProperty.get();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final OrthopteraStatement other = (OrthopteraStatement) obj;

        return
                // Compare first elements which are most likely to differ.
                Objects.equals(getCd_nom(), other.getCd_nom()) &&
                Objects.equals(getTrackingPoint(), other.getTrackingPoint()) &&
                Objects.equals(getDate(), other.getDate());
    }

    @Override
    public int hashCode() {
        Integer hash = 7;
        hash = 37 * hash + Objects.hashCode(getDate());
        hash = 37 * hash + Objects.hashCode(getTrackingPoint());
        hash = 37 * hash + Objects.hashCode(getCd_nom());
        return hash;
    }

    public static class OrthopteraOnly implements Predicate<Taxref> {
        @Override
        public boolean test(Taxref t) {
            return "orthoptera".equalsIgnoreCase(t.getOrdre());
        }
    }
}
